/* Copyright (C) 2000-2003 Markus Lausser (sgop@users.sf.net)
   This is free software distributed under the terms of the
   GNU Public License.  See the file COPYING for details. */

#define LIB_SHARED_NONE    0
#define LIB_SHARED_PART    1
#define LIB_SHARED_ALL     2

#define LIB_MOD_SHARE   0x01    // if internal share change
#define LIB_MOD_REM     0x02    // if removeable nodes

#define LIB_ACTION_REFRESH   1

void lib_save(library_t* lib, char* name);
void file_destroy(gpointer data);
GtkWidget *create_files_popup();
void lib_unshare_all(library_t* lib);
void lib_refresh(library_t* lib);
GtkWidget *create_lib2_popup(lib_node_t* node);
GtkWidget *create_lib1_popup(file_node_t* node);
library_t* lib_load_saved(char *fname);
library_t* lib_create_new(char* name);
char* calc_time(int val, time_t* tim);
void on_lib_value_changed(GtkAdjustment *adjustment,
			  gpointer user_data);
suffix_t *check_suffix(char *name, int mime);
file_t *file_create_from_local(char *longname);
void lib_do_search(search_t* search);
void lib_unshare_all_network(library_t* lib, net_t* net);
library_t* lib_new(char* name);
shared_folder_t* lib_add_folder(library_t* lib, char* folder, int type);
int lib_compare_folder(library_t* lib1, library_t* lib2);
void shared_folder_destroy(GList* slist);
void lib_destroy(library_t* lib);
void lib_share(library_t* lib, net_t* net);
